"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .alert import Alert, AlertTypedDict
from .jsonldcontext_union import JSONLdContextUnion, JSONLdContextUnionTypedDict
from .paginationinfo import PaginationInfo, PaginationInfoTypedDict
from datetime import datetime
from enum import Enum
from nws_api_client.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class AlertCollectionGeoJSONType(str, Enum):
    FEATURE_COLLECTION = "FeatureCollection"


class AlertCollectionGeoJSONFeatureTypedDict(TypedDict):
    properties: NotRequired[AlertTypedDict]
    r"""An object representing a public alert message.
    Unless otherwise noted, the fields in this object correspond to the National Weather Service CAP v1.2 specification, which extends the OASIS Common Alerting Protocol (CAP) v1.2 specification and USA Integrated Public Alert and Warning System (IPAWS) Profile v1.0. Refer to this documentation for more complete information.
    http://docs.oasis-open.org/emergency/cap/v1.2/CAP-v1.2-os.html http://docs.oasis-open.org/emergency/cap/v1.2/ipaws-profile/v1.0/cs01/cap-v1.2-ipaws-profile-cs01.html https://alerts.weather.gov/#technical-notes-v12

    """


class AlertCollectionGeoJSONFeature(BaseModel):
    properties: Optional[Alert] = None
    r"""An object representing a public alert message.
    Unless otherwise noted, the fields in this object correspond to the National Weather Service CAP v1.2 specification, which extends the OASIS Common Alerting Protocol (CAP) v1.2 specification and USA Integrated Public Alert and Warning System (IPAWS) Profile v1.0. Refer to this documentation for more complete information.
    http://docs.oasis-open.org/emergency/cap/v1.2/CAP-v1.2-os.html http://docs.oasis-open.org/emergency/cap/v1.2/ipaws-profile/v1.0/cs01/cap-v1.2-ipaws-profile-cs01.html https://alerts.weather.gov/#technical-notes-v12

    """


class AlertCollectionGeoJSONTypedDict(TypedDict):
    r"""A GeoJSON feature collection. Please refer to IETF RFC 7946 for information on the GeoJSON format."""

    type: AlertCollectionGeoJSONType
    features: List[AlertCollectionGeoJSONFeatureTypedDict]
    at_context: NotRequired[JSONLdContextUnionTypedDict]
    title: NotRequired[str]
    r"""A title describing the alert collection"""
    updated: NotRequired[datetime]
    r"""The last time a change occurred to this collection"""
    pagination: NotRequired[PaginationInfoTypedDict]
    r"""Links for retrieving more data from paged data sets"""


class AlertCollectionGeoJSON(BaseModel):
    r"""A GeoJSON feature collection. Please refer to IETF RFC 7946 for information on the GeoJSON format."""

    type: AlertCollectionGeoJSONType

    features: List[AlertCollectionGeoJSONFeature]

    at_context: Annotated[
        Optional[JSONLdContextUnion], pydantic.Field(alias="@context")
    ] = None

    title: Optional[str] = None
    r"""A title describing the alert collection"""

    updated: Optional[datetime] = None
    r"""The last time a change occurred to this collection"""

    pagination: Optional[PaginationInfo] = None
    r"""Links for retrieving more data from paged data sets"""
