"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .problemdetail import ProblemDetail, ProblemDetailTypedDict
from nws_api_client.types import BaseModel
from nws_api_client.utils import FieldMetadata, PathParamMetadata, QueryParamMetadata
import pydantic
from typing import Any, Dict, List, Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


class GetRadarStationMetadataRequestTypedDict(TypedDict):
    station_id: str
    r"""Radar station ID"""
    reporting_host: NotRequired[str]
    r"""Show RDA and latency info from specific reporting host"""
    host: NotRequired[str]
    r"""Show latency info from specific LDM host"""


class GetRadarStationMetadataRequest(BaseModel):
    station_id: Annotated[
        str,
        pydantic.Field(alias="stationId"),
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""Radar station ID"""

    reporting_host: Annotated[
        Optional[str],
        pydantic.Field(alias="reportingHost"),
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Show RDA and latency info from specific reporting host"""

    host: Annotated[
        Optional[str],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Show latency info from specific LDM host"""


GetRadarStationMetadataResponseResultTypedDict = TypeAliasType(
    "GetRadarStationMetadataResponseResultTypedDict",
    Union[ProblemDetailTypedDict, Any, Any],
)


GetRadarStationMetadataResponseResult = TypeAliasType(
    "GetRadarStationMetadataResponseResult", Union[ProblemDetail, Any, Any]
)


class GetRadarStationMetadataResponseTypedDict(TypedDict):
    headers: Dict[str, List[str]]
    result: GetRadarStationMetadataResponseResultTypedDict


class GetRadarStationMetadataResponse(BaseModel):
    headers: Dict[str, List[str]]

    result: GetRadarStationMetadataResponseResult
