"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .observationcollectiongeojson import (
    ObservationCollectionGeoJSON,
    ObservationCollectionGeoJSONTypedDict,
)
from .observationcollectionjsonld import (
    ObservationCollectionJSONLd,
    ObservationCollectionJSONLdTypedDict,
)
from .problemdetail import ProblemDetail, ProblemDetailTypedDict
from datetime import datetime
from nws_api_client.types import BaseModel
from nws_api_client.utils import FieldMetadata, PathParamMetadata, QueryParamMetadata
import pydantic
from typing import Dict, List, Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


class ListObservationsByZoneRequestTypedDict(TypedDict):
    zone_id: str
    r"""NWS public zone/county identifier"""
    start: NotRequired[datetime]
    r"""Start date/time"""
    end: NotRequired[datetime]
    r"""End date/time"""
    limit: NotRequired[int]
    r"""Limit"""


class ListObservationsByZoneRequest(BaseModel):
    zone_id: Annotated[
        str,
        pydantic.Field(alias="zoneId"),
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""NWS public zone/county identifier"""

    start: Annotated[
        Optional[datetime],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Start date/time"""

    end: Annotated[
        Optional[datetime],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""End date/time"""

    limit: Annotated[
        Optional[int],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Limit"""


ListObservationsByZoneResponseResultTypedDict = TypeAliasType(
    "ListObservationsByZoneResponseResultTypedDict",
    Union[
        ObservationCollectionJSONLdTypedDict,
        ObservationCollectionGeoJSONTypedDict,
        ProblemDetailTypedDict,
    ],
)


ListObservationsByZoneResponseResult = TypeAliasType(
    "ListObservationsByZoneResponseResult",
    Union[ObservationCollectionJSONLd, ObservationCollectionGeoJSON, ProblemDetail],
)


class ListObservationsByZoneResponseTypedDict(TypedDict):
    headers: Dict[str, List[str]]
    result: ListObservationsByZoneResponseResultTypedDict


class ListObservationsByZoneResponse(BaseModel):
    headers: Dict[str, List[str]]

    result: ListObservationsByZoneResponseResult
