"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .areacode import AreaCode
from .nwszonetype import NWSZoneType
from .problemdetail import ProblemDetail, ProblemDetailTypedDict
from .regioncode import RegionCode, RegionCodeTypedDict
from .zonecollectiongeojson import ZoneCollectionGeoJSON, ZoneCollectionGeoJSONTypedDict
from .zonecollectionjsonld import ZoneCollectionJSONLd, ZoneCollectionJSONLdTypedDict
from datetime import datetime
from nws_api_client.types import BaseModel
from nws_api_client.utils import FieldMetadata, QueryParamMetadata
from typing import Dict, List, Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


class ListZonesRequestTypedDict(TypedDict):
    id: NotRequired[List[str]]
    r"""Zone ID (forecast or county)"""
    area: NotRequired[List[AreaCode]]
    r"""State/marine area code"""
    region: NotRequired[List[RegionCodeTypedDict]]
    r"""Region code"""
    type: NotRequired[List[NWSZoneType]]
    r"""Zone type"""
    point: NotRequired[str]
    r"""Point (latitude,longitude)"""
    include_geometry: NotRequired[bool]
    r"""Include geometry in results (true/false)"""
    limit: NotRequired[int]
    r"""Limit"""
    effective: NotRequired[datetime]
    r"""Effective date/time"""


class ListZonesRequest(BaseModel):
    id: Annotated[
        Optional[List[str]],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=False)),
    ] = None
    r"""Zone ID (forecast or county)"""

    area: Annotated[
        Optional[List[AreaCode]],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=False)),
    ] = None
    r"""State/marine area code"""

    region: Annotated[
        Optional[List[RegionCode]],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=False)),
    ] = None
    r"""Region code"""

    type: Annotated[
        Optional[List[NWSZoneType]],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=False)),
    ] = None
    r"""Zone type"""

    point: Annotated[
        Optional[str],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Point (latitude,longitude)"""

    include_geometry: Annotated[
        Optional[bool],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Include geometry in results (true/false)"""

    limit: Annotated[
        Optional[int],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Limit"""

    effective: Annotated[
        Optional[datetime],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Effective date/time"""


ListZonesResponseResultTypedDict = TypeAliasType(
    "ListZonesResponseResultTypedDict",
    Union[
        ZoneCollectionJSONLdTypedDict,
        ZoneCollectionGeoJSONTypedDict,
        ProblemDetailTypedDict,
    ],
)


ListZonesResponseResult = TypeAliasType(
    "ListZonesResponseResult",
    Union[ZoneCollectionJSONLd, ZoneCollectionGeoJSON, ProblemDetail],
)


class ListZonesResponseTypedDict(TypedDict):
    headers: Dict[str, List[str]]
    result: ListZonesResponseResultTypedDict


class ListZonesResponse(BaseModel):
    headers: Dict[str, List[str]]

    result: ListZonesResponseResult
